// ==UserScript==
// @name           nlw_ng_newlink
// @namespace      kabeminT
// @description    ぬりかべの新着一覧のNG機能
// @include        *
// @compatibility  Firefox 3.6 4.0
// @author         kabeminT
// @version        2011/04/27 21:30
// ==/UserScript==


(function () {

//----------------------------------------//
//                設定項目                //
//----------------------------------------//
let NGlist = [ //NGリスト
	["url", "test"],
	["(title|comment)", "(ネタ|ねた)(バレ|ばれ)"],
];

let WhiteList = [ //ホワイトリスト
	["title", "NewLiveWall!"],
];

let enable_regexp = false; //正規表現を使うならtrue、使わないならfalse

let enable_icon = true; //壁にアイコンを表示するならtrue、しないならfalse
let enable_NG_newsdiv  = true; //新着コメントサイト一覧でNG処理をするならtrue
let enable_NG_newpopup = true; //右下の新着ポップアップでNG処理をするならtrue
let enable_NG_officialrank = true; //公式のランキングでNG処理をするならtrue
let enable_NG_officialnews = true; //公式の新着一覧でNG処理をするならtrue
//----------------------------------------//
//              設定ここまで              //
//----------------------------------------//


let inserted_nodes = [];
let check_timer = null;
let check_wait = 10;
let flag_initialized = false;

//右下ポップアップの最初の文字列
let mes_newcom  = "新しいコメントが投稿されました"
let mes_written = "書き込みしたサイトにコメントが投稿されました！";


//初期化処理
function initialize (){//{{{
	if(flag_initialized)
		return;
	flag_initialized = true;

	inserted_nodes = [];
	check_timer = null;

	if(enable_regexp){
		for(i=0; i<NGlist.length; i++){
			NGlist[i][0] = new RegExp(NGlist[i][0]);
			NGlist[i][1] = new RegExp(NGlist[i][1]);
		}
		for(i=0; i<WhiteList.length; i++){
			WhiteList[i][0] = new RegExp(WhiteList[i][0]);
			WhiteList[i][1] = new RegExp(WhiteList[i][1]);
		}
	}
}//}}}

//引数のurl,title,commentがNGリストに引っかかるか
function IsNG(url, title, comment){//{{{
	for(let j=0; j<NGlist.length; j++){
		if( (enable_regexp && (
		("url".match(NGlist[j][0])     && url.match(NGlist[j][1]))  ||
		("title".match(NGlist[j][0])   && title.match(NGlist[j][1]))||
		("comment".match(NGlist[j][0]) && comment.match(NGlist[j][1]))
		)) || (!enable_regexp &&(
		(NGlist[j][0]=="url"     && url.indexOf(NGlist[j][1])>=0)  ||
		(NGlist[j][0]=="title"   && title.indexOf(NGlist[j][1])>=0)||
		(NGlist[j][0]=="comment" && comment.indexOf(NGlist[j][1])>=0)
		))){
			return true;
		}
	}

	return false;
}//}}}

//引数のurl,title,commentがホワイトリストに引っかかるか
function IsWhite(url, title, comment){//{{{
	for(let j=0; j<WhiteList.length; j++){
		if( (enable_regexp && (
		("url".match(WhiteList[j][0])     && url.match(WhiteList[j][1]))  ||
		("title".match(WhiteList[j][0])   && title.match(WhiteList[j][1]))||
		("comment".match(WhiteList[j][0]) && comment.match(WhiteList[j][1]))
		)) || (!enable_regexp &&(
		(WhiteList[j][0]=="url"     && url.indexOf(WhiteList[j][1])>=0)  ||
		(WhiteList[j][0]=="title"   && title.indexOf(WhiteList[j][1])>=0)||
		(WhiteList[j][0]=="comment" && comment.indexOf(WhiteList[j][1])>=0)
		))){
			return true;
		}
	}

	return false;
}//}}}

//右下ポップアップまたは新着と思われるdiv要素を処理
function NG_newlink (div) {//{{{

	if(!flag_initialized)
		initialize();

	//リンクを取得
	let elemA = div.getElementsByTagName("a");
	let url;
	let title;
	let comment;

	if(div.id=="nlwNewDiv"){ //右下のポップアップ
		url   = elemA[0].href;
		title = elemA[0].text;

		if(div.textContent.indexOf(mes_newcom, 0)==0){
			comment = div.textContent.substring(mes_newcom.length+title.length, div.textContent.length);
		}
		else if(div.textContent.indexOf(mes_written, 0)==0){
			comment = div.textContent.substring(mes_written.length+title.length, div.textContent.length);
		}
		else{
			let num = div.textContent.indexOf(title, 0);
			comment = div.textContent.substring(num+title.length, div.textContent.length);
		}
	}
	else if(elemA.length >= 2){ //たぶん新着一覧のdiv
		url   = elemA[1].href;
		title = elemA[1].text;
		comment  = "";
	}
	else{ //その他の要素には何もしない
		return;
	}

	if( IsNG(url, title, comment) && !IsWhite(url, title, comment) ){
		div.style.display = "none";
	}
	
}//}}}

//ぬりかべ公式のNG処理
function NG_officialpage () {//{{{

	if(!flag_initialized)
		initialize();

	//リンクを取得
	let data;

	for(i=0; i<2; i++){
		if(i==0){
			if(!enable_NG_officialrank)
				continue;
			data = document.getElementById("nlwrankdata");
		}
		if(i==1){
			if(!enable_NG_officialnews)
				continue;
			data = document.getElementById("nlwdata");
		}
		let elemA = data.getElementsByTagName("a");
		let url;
		let title;
		let comment;

		for(k=1; k<elemA.length; k+=2){
			url     = elemA[k].href;
			title   = elemA[k].text;
			comment = "";

			if( IsNG(url, title, comment) && !IsWhite(url, title, comment) ){
				elemA[k].parentNode.style.display = "none";
			}
		}
	}
	
}//}}}

//アイコン追加
function create_icon (div) {//{{{
	if(!document.getElementById("nlwNGnewlinkPanel")) {
	   let panel = document.createElement("div");
	   panel.setAttribute("id", "nlwNGnewlinkPanel");
	   let icon = document.createElement("img");
	   icon.setAttribute("id", "nlwNGnewlinkIcon");
	   icon.src= 'data:image/png;base64,'+
	   	'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAIAAACQkWg2AAAAAXNSR0IArs4c6QAAAARnQU1BAACx'+
	   	'jwv8YQUAAAAgY0hSTQAAeiYAAICEAAD6AAAAgOgAAHUwAADqYAAAOpgAABdwnLpRPAAAAAlwSFlz'+
	   	'AAAOwwAADsMBx2+oZAAAAHNJREFUOE+tUVsOwCAIG7v/nRmmGbJKTUzmF2qhD8zdr/eYjSof6ArU'+
	   	'nWhqW99lQ3xgdnsaBolVkuBBkfQMJQjmk5JUj9VY9+pnSvbVS1eaMiQFSYKi2HOyhxZdOaXpCqoS'+
	   	'/lgcZmPqGsC0mH9pow3geA8Pp1crIB7PP+YAAAAASUVORK5CYII=';
	   icon.title="新着NGスクリプト";
	   panel.appendChild(icon);
	   panel.style.display="block";
	   panel.style.cssFloat="right";
	   panel.style.marginRight="16px";
	   document.getElementById('nlwDivTool').appendChild(panel);
	
	}
}//}}}

//ページに追加された要素がぬりかべの新着かどうかチェック
//DOMNodeInsertedは非同期にして使うべきだと聞いた
function check_nlwnew (e){//{{{
	//とりあえず追加された要素は積んでおいて
	inserted_nodes.push(e.target);

	//少し待ってから(check_wait)まとめて処理
	if(!check_timer){
		check_timer = setTimeout(function(){

			let parent;
			for(let i=0; i<inserted_nodes.length; i++){
				parent = inserted_nodes[i].parentNode;
				// 新着コメントサイト一覧
				if(enable_NG_newsdiv && parent && parent.id=="nlwNewsDiv"){
					if(inserted_nodes[i].tagName.toLowerCase()=="div"){
						NG_newlink(inserted_nodes[i]);
					}
				}

				// 右下の新着ポップアップ(閉じるボタンで判定)
				if(enable_NG_newpopup && inserted_nodes[i].id=="nlwNewCloseLink"){
					NG_newlink(parent);
				}

				// 壁の準備が出来たらアイコン追加
				if(enable_icon && inserted_nodes[i].id=="nlwResizeMark"){
					create_icon(parent);
				}
			}

			inserted_nodes = [];
			check_timer = null;
		}, check_wait);
	}
}//}}}


document.addEventListener("DOMNodeInserted", check_nlwnew, false);

initialize();
if(location.href == "http://nlwnewg.appspot.com/"){
	NG_officialpage();
}


})();


// vim: set tabstop=4 shiftwidth=4 softtabstop=4 fdm=marker :
